
#include "V.h"
/*
* Wrapper for the execve() system call.  Note that we close extraneous files.
* However, note especially that we leave the Vout stream open.  This has
* caused problems when the child process doesn't know to reopen Vout in
* response to a CONT signal.
*/
d_execve(name,argv,envv)
	char *name;
	char**argv;
	char**envv;
{	int  i, r;
	if (Vlvl > 4) {
		P2 "%s execve(\"%s\",%08X,%08X)",Vtime(),name,argv,envv D;
		dumpv(argv,"argv");
		dumpv(envv,"envv");
	}
	for (i=3; i<=openfilemax; i++)
		if (i != Fileno(Vout))
			Close(i);
	errno = 0;
	r = execve(name,argv,envv);
	V6 "execve()=%d	[Err %d=%s=%s]",r,Errinfo D;
	return r;
}
