
#include "V.h"
/*
* Return the name of a file.  Note that the caller can pass us a  file
* descriptor  or a file pointer.  If we can't figure it out, we return
* m_unknown.  Note that, if you want to make sure  we  use  the  FILE*
* second arg, you should pass a negative number for arg 1. But if f is
* non-negative yet has no name, we will pass it by and try  to  return
* the  name  for  p.   In  any  case,  we always return a pointer to a
* printable string, so you can safely feed the return value to printf.
*/
char *
Vfilnam(f,p)
	int  f;	/* File descriptor */
	FILE*p;	/* File pointer */
{	char *r=0;
	File *fp;
	Fenter("Vfilnam");
	if (f >= 0 && f <= openfilemax && (fp = d_openfile(f)))
		if (r = fp->name.v)
			Done;
	if (p && (f = Fileno(p)) >= 0 && f <= openfilemax && (fp = d_openfile(f)))
		if (r = fp->name.v)
			Done;
	r = m_unknown;
done:
	if (!r) r = unknown;
	Fexit;
	return r;
}
