
#include "V_s_lc.h"
/*
* Here's our wrapper for the ioctl-catching system call.  Note that we
* generate a rather detailed debug message at level 4.  This is a rather
* difficult part of most programs...
*/

#if defined(USE_syscall) && defined(SYS_ioctl)
ioctl(f,b,a) char *b; {return Ioctl(f,b,a);}
#endif

d_ioctl(f,r,a)
	int   f;
	Ulong r;
	char *a;
{	int   i;
	int   e;

/*	errno = 0; */
#if defined(USE_syscall) && defined(SYS_ioctl)

	i = syscall(SYS_ioctl,f,r,a);
	e = errno;
	V6s "syscall(SYS_ioctl,%d,%08lX,%d)=%d [Err %d=%s=%s]",f,r,a,i,Errlist D;
#else

	i = ioctl(f,r,a);
	V6s "ioctl(%d,%08lX,%d)=%d [Err %d=%s=%s]",f,r,a,i,Errlist D;
	e = errno;
#endif
	V6s "ioctl(%d,0%o,%08X)=%d [Err %d=%s=%s]",f,r,a,i,Errlist D;
	errno = e;
	return(i);
}
