#ifndef	local_h
#define	local_h
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* All the per-architecture stuff has been moved to this one header file. This
* is a header file for the AIX System/9000.  Define or undef the following as
* appropriate:
*/
#undef	BSD		/* Any BSD */
#undef	BSV43		/* 4.3 BSD */
#undef	ULTRIX		/* [jc 89/12/19] */
#undef	ULTRIX2_2	/* Ultrix 2.2 or 2.0 */
#undef	ULTRIX3_0	/* Ultrix 3.0 */
#undef	SUN3_3PLUS	/* Sun OS 3.3 or greater, but < 4.0 */
#undef	Sequent		/* Sequent Dynix */
#undef	SUN40		/* Sun OS 4.0 */
#undef	SUN386		/* Sun 386i */
#undef	SUN40_386	/* Sun 386i with 4.0 */
#define	SYS5		/* Any Sys/V [jc 89/12/12] */
#define	AIX		/* Any AIX [jc 95/3/3] */
#define	AIX3		/* AIX 3 [jc 95/3/3] */
#define	AIX3		/* AIX 3 [jc 95/3/3] */
#define	AIX3_1		/* AIX 3.1 [jc 95/3/3] */
#define	AIX_3		/* AIX 3 [jc 95/3/3] */
#define	AIX_3_1		/* AIX 3.1 [jc 95/3/3] */
#undef	SYS5_2		/* Sys/V Release 2 [jc 90/06/08] */
#undef	SYS5_3		/* Sys/V Release 3 [jc 90/06/08] */
#undef	SYS5_4		/* Sys/V Release 4 [jc 90/06/08] */
#undef	ESIX		/* Sys/V Release 3 or 4 from Everex */
#undef	ESIX3		/* Sys/V Release 3 from Everex */
#undef	ESIX4		/* Sys/V Release 4 from Everex */
#undef	HP			/* Hewlett/Packard */
#undef	HP9000		/* Hewlett/Packard 9000 */
#undef	HP9000s300	/* Hewlett/Packard 9000s300 */
#undef	SG		/* Silicon Graphics [jc 89/12/12] */
#undef	SG_IRIS3030	/* Silicon Graphics Iris 3030 [jc 89/12/12] */

#define	GTE	/* GTE extensions */
#undef	ATM	/* ATM extensions */
#define	NDC	/* NDC extensions */

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* The ESIX Sys/VR4 can't compile any of the termio stuff properly if we
* say we want POSIX compliance.
*/
#undef	POSIX_SOURCE 	/* Encourage the use of the POSIX standard */
#undef	_POSIX_SOURCE 	/* Several names are used (of course ;-) */
/* #define	NCC 8	/* required by termio.h but not defined for POSIX */
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* Define exactly one of the following, to tell  uutty  which  of  the  various
* terminal interface packages ("line disciplines") to use. See the makeraw and
* makesane modules for the main uses of these.  Other packages might make  use
* of these symbols to gain more portability.
*/
#undef	USE_sgtty 
#define	USE_termio 
#undef	USE_termios
#define	DTR_time 3	/* How long to keep DTR low - see DTRdu() */
#undef	USE_waitstruct
#define	USE_waitint
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* Define one of the following, to tell uutty how to determine this machine's
* symbolic name.
*/
#undef	USE_gethostname 
#define	USE_utsname 
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* Do we want to compile the code for remote network-management agents?
*/
#define	USE_agent 1

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* Some assorted modules that we might want to use:
*/
#undef	USE_SHM	/* Whether to use the shared-memory package */
#undef	USE_syscall	/* Whether to use the syscall() routine */

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* Define exactly one to say which directory package to use:
*/
#undef	USE_direct
#define	USE_dirent
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* Does this system use /etc/shadow and the getspent(3C) routines?
*/
#define	USE_shadow
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* Here are some symbols to tell the compiler what library routines exist here.
* On systems where they are missing, we need to do them ourself, or at least
* implement some minimal part of the functionality.  If you have the "locsym"
* perl program, you can answer these very quickly.
*/
#define	HAS_bcopy 1	/* This sytem has a usable bcopy() */
#define	HAS_bzero 1	/* This sytem has a usable bzero() */
#define	HAS_mbuf
#undef	HAS_getutent
#undef	HAS_pututent
#define	HAS_rename	/* The rename() call exists and IS ATOMIC!!! */
#define	HAS_select	/* The select() call exists */
#undef	HAS_setutent
#define	HAS_strtok	/* Some "standard" C libraries lack this */
#undef	HAS_getutline
#undef	HAS_pututline
#define	HAS_socket
#define	HAS_select
#undef	HAS_setutline
#undef	HAS_S_un	/* Is this IPaddr struct defined here? */
#define	HAS_ttyslot
#define	USE_stdlib
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* Pick a set of these that works on your system:
*/
#undef	USE_re_comp	/* Most BSD systems */
#undef	USE_re_exec	/* Most BSD systems */
#define	USE_regcmp	/* Most USG systems */
#define	USE_regex	/* Most USG systems */
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* Exactly one of these should be defined, to determine  which  way  we
* should check for input:
*/
#undef	USE_alarm	/* The alarm doesn't always get delivered on Sys/V */
#undef	USE_jmp		/* Setjmp may or may not cooperate with Alarm */
#undef	USE_poll	/* Streams polling scheme, missing on some BSD releases */
#define	USE_select	/* BSD polling scheme, flakey on some Sys/V releases */
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* Some symbols to say whether networking stuff like Select() are enabled.
*/
#define	NET 1	/* Generic networking stuff */
#define	BSDNET 1	/* BSD-style networking stuff */
#define	NFSNET 1	/* NFS-related networking stuff */
#define	RFSNET 1	/* RFS-related networking stuff */
#define	X25NET 0	/* X.25 networking stuff */
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* Here are some things that everyone always wants:
*/
#ifndef	FILE
#include	<stdio.h>
#endif
#ifndef	OPEN_MAX
#include	<limits.h>
#endif
#ifndef	_STRING_H
#include	<string.h>
#endif
#ifndef	V_h
#include	"V.h"
#endif
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
*/
#define	LITTLENDIAN	/* Byte order 1234, low-order byte first */
#undef	BIGENDIAN	/* Byte order 4321, high-order first */
#undef	MIXEDENDIAN	/* Byte order 2143, on some 16-bit cpus */

#undef	SYSLOG		/* Define if the syslog package exists here */
#undef	USE_syslog	/* Define if compile the syslog code */

#define	NULB (byte*)0	/* Null pointer (unsigned) */
#define	NULC (char*)0	/* Null pointer (signed) */
#define	NULP (void*)0	/* Null pointer (generic) */
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
*/
#ifndef	MEMUNIT		/* Define memory chunk-size for str.h as 4 bytes */
#define	MEMUNIT(n) (((int)(((int)(n)+3)>>2))<<2)
#endif
#define	getime() Vtime()
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* We need to know where UUCP keeps its lockfiles, and put ours there, too.
*/
#define	BNU    1	/* ATT's acronym for HDB UUCP */
#define	LCKNEW 1	/* Use "LK." rather than "LCK.." lockfiles */
#define	LCKDIR "/usr/spool/locks"
#define	LCKPFX "LK."
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* Here's some stuff to keep lint happy:
*/
extern int atoi();
extern int getpid();
extern int putenv();
extern void exit();
extern void _exit();
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* Here's some stuff that AIX gets wrong:
*/
#ifndef	ISupper
#define	ISupper(x) (('A'<=(x))&&((x)<='Z'))
#endif

#endif
