#include "V.h"
#include "sys_pthreads.h"

#if defined(USE_pthreads) && (USE_pthreads > 0)

FCT	V_ptlock()
{	int r=0;
	Fenter("V_ptlock");
	if (V_locking && use_pthreads) {;
#if defined(USE_pthreads) && (USE_pthreads > 0)
		if (Vlvl>2) {fputs("Get global pthreads lock ...\n",Vout); fflush(Vout);}
		pthread_lock_global_np();
		if (Vlvl>2) {fputs("Got global pthreads lock.\n",Vout); fflush(Vout);}
#endif /*USE_pthreads*/
		;
	} else {
		if (Vlvl>2) {fputs("Not using pthreads.\n",Vout); fflush(Vout);}
	}
	Fexit;
	return r;
}

FCT	V_ptunlock()
{	int r=0;
	Fenter("V_ptunlock");
	if (V_locking && use_pthreads) {;
#if defined(USE_pthreads) && (USE_pthreads > 0)
		if (Vlvl>2) {fputs("Free global pthreads lock ...\n",Vout); fflush(Vout);}
		pthread_unlock_global_np();
		if (Vlvl>2) {fputs("Freed global pthreads lock.\n",Vout); fflush(Vout);}
#endif /*USE_pthreads*/
		;
	} else {
		if (Vlvl>2) {fputs("Not using pthreads.\n",Vout); fflush(Vout);}
	}
	Fexit;
	return r;
}

#endif	/* USE_pthreads */
