#include "V.h"
#include "sys_signal.h"
/*
* Here's our wrapper for the sigaction signal-catching system call.  Note that
* we  generate  a rather detailed debug message at level 4.  This is the POSIX
* "solution" to the problem of how to do interrupts right.
*/
d_sigaction(sig,svec,ovec,msg)
	int   sig;
	struct sigaction *svec;
	struct sigaction *ovec;
	char *msg;
{	int   i;

	errno = 0;
	i = (Ulong)sigaction(sig,svec,ovec);
	V4 "sigaction(%d,%08lX,%08lX)=%d \"%s\" [Err %d=%s=%s]",
		sig,svec,ovec,i,msg,Errinfo D;
	return i;
}
